﻿package gameplay {

	import flash.display.MovieClip;
	import flash.utils.Timer;
	import flash.events.TimerEvent;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.ui.Keyboard;
	import fl.transitions.Tween;
	import fl.motion.easing.Bounce;

	public class Gameplay extends MovieClip {

		public var frutas: Frutas
		public var sort: Number
		public var wait: Number
		public static var lifes: Number
		public static var temposort: Timer
		public static var acertos: Number
		public var anim: Tween

		public function Gameplay() {
			// constructor code
			addEventListener(Event.ADDED_TO_STAGE, inita)
		}
		public function inita(e: Event) {
			// constructor code
			trace("inicia gameplay")
			stop()
			removeEventListener(Event.REMOVED_FROM_STAGE, inita)
			addEventListener("updateData", atualiza)
			addEventListener("gameover", gameisover)
			stage.focus = stage;
			startGame()

		}
		public function atualiza(e: Event) {
			devoratxt.text = String(acertos)
			if (acertos >= 50) {
				temposort.stop()
				MovieClip(parent).gotoAndStop("final")
			} else if (acertos >= 45) {
				trace("muda pra mal")
				personagem.gotoAndStop("deus")
			} else if (acertos >= 35) {
				trace("muda pra bem")
				personagem.gotoAndStop("forte")
			} else if (acertos >= 25) {
				personagem.gotoAndStop("bem")
			}else if (acertos >= 15) {
				personagem.gotoAndStop("mal")
			} else if (acertos >= 10) {
				personagem.gotoAndStop("doente")
			}
		}

		public function startGame() {

			trace("inicia game")
			lifes = 20
			acertos = 0
			temposort = new Timer(400)
			temposort.addEventListener(TimerEvent.TIMER, conta)
			temposort.start()
			stage.addEventListener(KeyboardEvent.KEY_DOWN, tecla)

		}


		public function conta(e: TimerEvent) {

			if (Gameplay.acertos < 10) {
				temposort.removeEventListener(TimerEvent.TIMER, conta)
				temposort = new Timer(380)
				temposort.addEventListener(TimerEvent.TIMER, conta)
				temposort.start()

				sort = Math.round(Math.random() * 6)
			} else if (Gameplay.acertos < 20) {

				temposort.removeEventListener(TimerEvent.TIMER, conta)
				temposort = new Timer(360)
				temposort.addEventListener(TimerEvent.TIMER, conta)
				temposort.start()

				sort = Math.round(Math.random() * 4)
			} else if (Gameplay.acertos < 40) {
				temposort.removeEventListener(TimerEvent.TIMER, conta)
				temposort = new Timer(320)
				temposort.addEventListener(TimerEvent.TIMER, conta)
				temposort.start()

				sort = Math.round(Math.random() * 3)
			} else if (Gameplay.acertos < 60) {
				temposort.removeEventListener(TimerEvent.TIMER, conta)
				temposort = new Timer(280)
				temposort.addEventListener(TimerEvent.TIMER, conta)
				temposort.start()

				sort = Math.round(Math.random() * 2)
			}
			//trace("sorteio", sort)
			if (sort == 1) {
				//trace("solta fruta")
				frutas = new Frutas
				esteiraHolder.addChild(frutas)
			}
		}
		public function tecla(e: KeyboardEvent) {
			i
			if (e.keyCode == Keyboard.A) {
				tuina(limitbar.alvo1)
			} else if (e.keyCode == Keyboard.Q) {
				tuina(limitbar.alvo2)
			} else if (e.keyCode == Keyboard.W) {
				tuina(limitbar.alvo3)
			} else if (e.keyCode == Keyboard.Z) {
				tuina(limitbar.alvo4)
			} else if (e.keyCode == Keyboard.S) {
				tuina(limitbar.alvo5)
			}

			if (esteiraHolder.numChildren > 0) {
				var selFruit: MovieClip = esteiraHolder.getChildAt(i) as MovieClip
				for (var i: int; i < esteiraHolder.numChildren; i++) {
					selFruit.validacao(e.keyCode)
				}
			}
		}

		public function tuina(alvo: MovieClip) {
			//trace("tuuuiinaa")
			anim = new Tween(alvo, "scaleX", Bounce.easeOut, 1.3, 1, .5, true)
			anim = new Tween(alvo, "scaleY", Bounce.easeOut, 1.3, 1, .5, true)

		}

		public function gameisover(e: Event) {
			trace("gameover")
			temposort.stop()
			MovieClip(parent).gotoAndStop("gameover")
		}

	}

}